src/medux/employees/urls.py
from django.urls import path
from . import views
from medux.common.api.interfaces import IAdministrationURL

app_name = "employees"

urlpatterns = [
    # WorkingContract
    path(
        "<int:pk>/contracts/current/",
        views.WorkingContractWidgetView.as_view(),
        name="workingcontract-current",
    ),
    path(
        "<int:employee_pk>/contracts/<int:pk>/",
        views.WorkingContractUpdateView.as_view(),
        name="workingcontract-change",
    ),
    path(
        "<int:employee_pk>/contracts/add/",
        views.WorkingContractCreateView.as_view(),
        name="workingcontract-create",
    ),
    path(
        "<int:pk>/contract/<int:contract_pk>/salary/",
        views.SalaryView.as_view(),
        name="salary",
    ),
]


class EmployeeAdministrationURL(IAdministrationURL):
    namespace = "employee"
    urlpatterns = [
        path(
            "",
            views.TenantEmployeeListView.as_view(),
            name="list",
        ),
        # path(
        #     "<int:pk>/",
        #     views.TenantEmployeeDetailView.as_view(),
        #     name="detail",
        # ),
        path(
            "<int:pk>/change/",
            views.TenantEmployeeUpdateView.as_view(),
            name="update",
        ),
        path(
            "add/",
            views.TenantEmployeeCreateView.as_view(),
            name="add",
        ),
    ]

src/medux/urls.py
import logging

from django.conf.urls.static import static
from django.urls import path, include
from django.contrib import admin
from django.conf import settings
from gdaps.pluginmanager import PluginManager

logger = logging.getLogger(__name__)


urlpatterns = [
    path("admin/", admin.site.urls),
    # use django-statici18n instead
    # path("jsi18n/", JavaScriptCatalog.as_view(), name="javascript-catalog"),
] + PluginManager.urlpatterns()


if settings.DEBUG_TOOLBAR:
    try:
        import debug_toolbar

        urlpatterns += [
            path("__debug__/", include(debug_toolbar.urls)),
        ]
    except ImportError:
        logger.warning(
            "Debug Toolbar not available. Please install it or set DEBUG to False."
        )

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATICI18N_ROOT)

src/medux/employees/models.py
import calendar
import decimal
import typing

from datetime import timedelta, date
from django.contrib.auth import get_user_model
from django.core.exceptions import ValidationError
from django.db import models
from django.db.models import Sum, F, Q
from django.utils import timezone
from django.utils.formats import date_format, time_format
from django.utils.translation import gettext_lazy as _
from djmoney.models.fields import MoneyField

from medux.common.constants import DaysOfWeek
from medux.common.models import BaseModel, Tenant, CreatedModifiedModel

User = get_user_model()


class Classification(models.Model):
    """The classification in an employment context.

    This could be "doctor", "nurse", etc.
    """

    class Meta:
        verbose_name = _("Classification")
        verbose_name_plural = _("Classifications")

    name = models.CharField(max_length=255)

    def __str__(self):
        return self.name


class Application(models.Model):
    """The "usage field" of an employee.

    Could be "medical assistent"
    """

    class Meta:
        verbose_name = _("Application")
        verbose_name_plural = _("Applications")

    name = models.CharField(max_length=255)

    def __str__(self):
        return self.name


class WorkingContract(BaseModel):
    """A contract a user has with his employer.

    Working hours, salary, and other details should be fixed within a contract,
    for a given period.
    """

    class Meta:
        verbose_name = _("Working contract")
        verbose_name_plural = _("Working contracts")

    employee = models.ForeignKey(
        "Employee", on_delete=models.CASCADE, related_name="working_contracts"
    )
    tenant = models.ForeignKey(Tenant, on_delete=models.CASCADE)
    start_date = models.DateField(
        _("Start date"), help_text=_("Start date of this contract")
    )
    end_date = models.DateField(
        _("End date"), help_text=_("End date of this contract"), blank=True, null=True
    )
    employment_date = models.DateField(
        _("Employment date"),
        help_text=_("First date of employment at this working place"),
        blank=True,
    )
    notice_period_weeks = models.PositiveIntegerField(
        _("Notice period in weeks"), blank=True, null=True
    )
    notice_period_months = models.PositiveIntegerField(
        _("Notice period in months"), blank=True, null=True
    )
    # location = models.ForeignKey(Practice)
    classification = models.ForeignKey(Classification, on_delete=models.PROTECT)
    intended_application = models.ForeignKey(Application, on_delete=models.PROTECT)
    initial_salary = MoneyField(max_digits=14, decimal_places=2, default_currency="EUR")
    salary_notice = models.TextField(
        _("Additional notice for salary"), blank=True, null=True
    )
    holiday_year_is_calendar_year = models.BooleanField(
        default=False,
        help_text=_(
            "If activated, the holiday year is the same as a calendar year, "
            "else it starts at the employment date."
        ),
    )

    def __str__(self):
        # return f"{self._meta.verbose_name}.."
        end_date = (
            f" - {date_format(self.end_date, 'SHORT_DATE_FORMAT')}"
            if self.end_date
            else ""
        )
        return (
            f"{self.employee}: {date_format(self.start_date, 'SHORT_DATE_FORMAT')}"
            f"{end_date}"
        )

    def clean(self):
        """Set employment_date if empty"""
        if not self.employment_date:
            self.employment_date = self.start_date

    def duration(self) -> timedelta:
        """The duration of that contract in days.

        If contract has no end date, count until today (including the day today)
        """
        if self.end_date:
            end_date = self.end_date
        else:
            end_date = timezone.now().date() + timedelta(days=1)  # =tomorrow 0:00
        return end_date - self.start_date

    def days_in_year(self, year) -> timedelta:
        """Returns timedelta from Jan 1st (or contract start) until Dec 31th (or
        contract end) for given year."""

        year_start = date(year, 1, 1)
        year_end = date(year, 12, 31)
        # start date is Jan 1st or contract start (if this year)
        start = year_start if self.start_date < year_start else self.start_date
        if self.end_date:
            # end date is Dec 31th or contract end (if this year)
            end = year_end if self.end_date > year_end else self.end_date
        else:
            # no contract end: take Dec 31st
            end = year_end

        # add one day, to include the last day.
        end += timedelta(days=1)

        # if contract doesn't touch given year at all, return 0
        if end.year < year or start.year > year:
            return timedelta(0)

        delta = end - start
        if delta.days < 0:
            delta = timedelta(0)
        return delta

    def is_active(self, day: date = None):
        if not day:
            day = timezone.now().date()
        return self.employee.active_working_contract(day) is not None

    def create_subsequent_contract(self, new_start_date: date) -> "WorkingContract":
        """Closes this contract one day before new_start_date, and returns an (unsaved)
        copy contract subsequently following the old one."""
        self.end_date = new_start_date - timedelta(days=1)
        self.save()
        return WorkingContract(
            employee=self.employee,
            tenant=self.tenant,
            start_date=new_start_date,
            employment_date=self.employment_date,  # stays the same
            notice_period_weeks=self.notice_period_weeks,
            notice_period_months=self.notice_period_months,
            classification=self.classification,
            intended_application=self.intended_application,
            initial_salary=self.initial_salary,
            salary_notice=self.salary_notice,
        )


class WorkSchedule(CreatedModifiedModel):
    """A set of working hour ranges, for one user / one week, in a valid time range.

    E.g. Mon 8-12, Tue 8-12, Wed-Fr 9-11

    [WorkingTimeRange] has a ForeignKey to this class, so you can access them using
    `self.working_hours`.

    There can be more WorkSchedules for one WorkingContract: Within a contract, you just
    can change the working hours, hence changing the WorkSchedule.
    """

    class Meta:
        verbose_name = _("Work schedule")
        verbose_name_plural = _("Work schedules")

    employee = models.ForeignKey(
        "Employee", on_delete=models.CASCADE, related_name="work_schedules"
    )
    start_date = models.DateField(_("Start date"), default=timezone.localdate)
    end_date = models.DateField(_("End date"), blank=True, null=True)
    working_contract = models.ForeignKey(
        WorkingContract,
        on_delete=models.CASCADE,
        related_name="work_schedules",
        null=True,  # FIXME - this must not be there.
    )

    def total_working_time(self) -> timedelta:
        total_hours = self.working_hours.all().aggregate(
            total=Sum(F("end_time") - F("start_time"))
        )
        return total_hours["total"] or timedelta(0)

    def total_working_time_h(self) -> decimal.Decimal:
        t = self.total_working_time()
        return decimal.Decimal(t.days * 24 * 60 * 60 + t.seconds) / (60 * 60)

    def work_days_per_week(self) -> int:
        """Returns the number of days per week the employee is working during this
        period.

        This takes into account that more than one WTR per day may be possible.
        """
        # TODO: maybe optimize this function by using one DISTINCT SQL query
        #       (=aggregate/sum in Django)
        weekdays = set()
        for wtr in self.working_hours.all():
            weekdays.add(wtr.weekday)
        return len(weekdays)

    def __str__(self) -> str:
        active = (
            " [" + _("active") + "]"
            if not self.end_date
            else date_format(self.end_date, "SHORT_DATE_FORMAT")
        )
        return (
            f"{self.employee}: {date_format(self.start_date,'SHORT_DATE_FORMAT')}"
            f" - {active} "
            f"({self.total_working_time_h()})"
        )

    @classmethod
    def get_active(cls, employee) -> typing.Union["WorkSchedule", None]:
        """Returns "active" work schedule, which is the one that has no end date.

        there *has* to be only one WorkSchedule that is "active", meaning:
         * start date <= today
         * no end date, or
         * end date in future
        """
        try:
            return cls.objects.get(
                Q(employee=employee),
                Q(start_date__lte=timezone.now()),
                Q(end_date__isnull=True) | Q(end_date__gte=timezone.now()),
            )
        except cls.DoesNotExist:
            return None

    def clean(self):
        error_list = []
        # check if there is another schedule that starts *after* self
        if not self.end_date:
            active = self.get_active(self.employee)

            if active and active != self:
                if active.start_date >= self.start_date:
                    raise ValidationError(
                        {
                            "start_date": _(
                                "There is another active work schedule ({active})"
                                " that begins after this one."
                            ).format(active=active)
                        }
                    )
            # is there another WorkSchedule without end date?
            overlapping_list = WorkSchedule.objects.filter(
                employee=self.employee, end_date__isnull=True
            ).exclude(pk=self.pk)
        else:
            # is there another WorkSchedule that overlaps or has no end date?
            overlapping_list = WorkSchedule.objects.filter(
                Q(employee=self.employee),
                Q(start_date__lte=self.end_date),

src/medux/employees/forms.py
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Row, Column, ButtonHolder, Submit, Layout
from django import forms
from django.urls import reverse

from .models import Employee


class TenantEmployeeForm(forms.ModelForm):
    class Meta:
        model = Employee
        fields = [
            "username",
            "title",
            "first_name",
            "last_name",
            "email",
            "is_active",
            "color",
            "avatar",
        ]

    def __init__(self, **kwargs):
        super().__init__(**kwargs)
        self.helper = FormHelper()
        if self.instance.pk:
            self.fields["username"].disabled = True
            self.helper.form_action = reverse(
                "adm:employee:update", kwargs={"pk": self.instance.pk}
            )
        else:
            self.helper.form_action = reverse("adm:employee:add")
        self.helper.layout = Layout(
            Row(Column("username"), Column("is_active", css_class="col-12 col-md-3")),
            Row(
                Column("title", css_class="col-12 col-md-2"),
                Column("first_name"),
                Column("last_name"),
            ),
            "email",
            "color",
            "avatar",
            ButtonHolder(
                Submit("save", "Save"),
            ),
        )

src/medux/employees/templates/employees/adm_employee_tab.html
{% load i18n crispy_forms_tags %}
{% if form %}
  {% crispy form %}
{% else %}
  <div
      hx-get="{% url component.get_url_name employee.id %}"
      hx-trigger="load"
  >
    {% translate 'Please select a user.' %}
  </div>
{% endif %}

src/medux/employees/templates/employees/adm_employee_tab_contracts.html
{% block content %}
    {# List all contracts #}
    <div class="list-group mt-2">
        <div class="card-actions">
            <button class="btn btn-action"
                    hx-get="{% url 'employees:workingcontract-create' employee_pk=employee.pk %}"
                    hx-target="#dialog"
            ><i class="bi bi-plus-lg"></i></button>
        </div>
        {# TODO: highlight the workingcontract that is active #}
        {% for contract in workingcontract_list %}
            <div class="list-group-item{% if contract.is_active %} active{% endif %}">
                <div class="row align-items-center">
                    <div class="col text-truncate">
                        {{ contract.start_date }}
                        {% if contract.end_date %} - {{ contract.end_date }}{% endif %}
                    </div>
                    <div class="col-auto">
                        <div class="list-group-item-actions">
                            <button class="btn btn-action"
                                    hx-get="{% url 'employees:workingcontract-change' employee_pk=employee.pk pk=contract.pk %}"
                                    hx-target="#dialog"
                            ><i class="bi bi-pencil"></i></button>
                        </div>
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>

{% endblock %}

src/medux/employees/templates/employees/adm_employee_tab_masterdata.html
{% load i18n crispy_forms_tags %}
{% if form %}
  {% crispy form %}
{% else %}
  <div
      hx-get="{% url component.get_url employee.id %}"
      hx-trigger="load"
  >
    {% translate 'Please select a user.' %}
  </div>
{% endif %}

src/medux/employees/templates/employees/adm_tenant_employees.html
{% extends 'common/administration.html' %}
{% load i18n crispy_forms_tags %}

{# No header shown #}
{% block page-header %}{% endblock %}

{% block card-actions %}
  {% url "adm:employee:add" as link_url %}
  <button
      class="btn btn-action"
      type="button"
      hx-get="{{ link_url }}"
      hx-target="#page-body"
      hx-select="#page-body"
      hx-swap="outerHTML"
      hx-push-url="{{ link_url }}"><i class="bi bi-plus-lg"></i></button>
{% endblock %}

{% block card-body %}
  <div class="row">
    <div class="col-2 border-end overflow-auto pe-0">
      <div class="list-group list-group-flush ">
        {% for employee in employee_list %}
          {% url "adm:employee:update" employee.pk as link_url %}
          <div
              class="list-group-item cursor-pointer{% if request.path == link_url %} active{% endif %}{% if not employee.is_active %} text-decoration-line-through bg-gray-900{% endif %}"
              title="{{ employee }}"
          >
            <div
                class="row align-items-center"
                hx-get="{% url 'adm:employee:update' pk=employee.id %}"
                hx-target="#page-body"
                hx-select="#page-body"
                hx-swap="outerHTML"
                hx-push-url="{% url 'adm:employee:update' pk=employee.id %}"
            >
              {#              <div class="col-auto">#}
              {#                <input type="checkbox" name="check-employee-{{ employee.id }} }}class="form-check-input">#}
              {#              </div>#}
              <div class="col-auto">
                {#                <a#}
                {#                    hx-get="{% url 'adm:employee:update' pk=employee.id %}"#}
                {#                    hx-target="#employee-content"#}
                {#                >#}
                <span
                    class="avatar bg-{{ employee.color }}"
                    {% if employee.avatar %}style="background-image: url({{ employee.avatar.url }})"{% endif %}
                ></span>
                {#                </a>#}
              </div>
              <div class="col text-truncate">
                {#                <a#}
                {#                    href="#"#}
                {#                    class="text-reset d-block"#}
                {#                >#}
                <div

                    {% if not employee.is_active %}class="text-muted"{% endif %}
                >
                  {{ employee.last_name|upper }}<br/>{{ employee.first_name }}
                </div>
                {#                </a>#}
                {#                <div class="d-block text-muted text-truncate mt-n1">...</div>#}
              </div>
            </div>

          </div>
        {% endfor %}
      </div>
    </div>
    <div id="employee-detail" class="col-10 p-2">
      <nav>
        <div class="nav nav-tabs" id="nav-tab" role="tablist">
          {% for component in components.IEmployeeFormTab %}
            <button
                class="nav-link{% if component.name == active_component or not active_component and forloop.first %} active{% endif %}"
                id="nav-{{ component.name }}-tab"
                data-bs-toggle="tab"
                data-bs-target="#nav-{{ component.name }}"
                type="button"
                role="tab"
                {% if component.enabled %}
                hx-get="{% url component.get_url_name employee.id %}"
                hx-trigger="{% if component.name == active_component or not active_component and forloop.first %}load, {% endif %}click once"
                hx-target="#nav-{{ component.name }}"
                hx-push-url="?tab={{ component.name }}"
                {% else %}
                disabled
                {% endif %}
                aria-controls="nav-{{ component.name }}"
                aria-selected="{% if forloop.first %}true{% else %}false{% endif %}"
            >
              <i class="bi bi-{{ component.icon }} me-2"></i>
              {{ component.title }}
            </button>
          {% endfor %}
        </div>
      </nav>

      <div class="tab-content" id="nav-tabContent">
        {% for component in components.IEmployeeFormTab %}
          <div class="tab-pane fade{% if forloop.first %} active show{% endif %}"
               id="nav-{{ component.get_name }}"
               role="tabpanel"
               aria-labelledby="nav-{{ component.get_name }}-tab"
               tabindex="0"
              {% if component.enabled %}
               hx-get="{% url component.get_url_name employee.id %}"
               {% if component.name == active_component or not active_component and forloop.first %}hx-trigger="load"{% endif %}
               hx-push-url="?tab={{ component.name }}"
              {% else %}
               disabled
              {% endif %}

          ></div>
        {% endfor %}
      </div>

    </div>
  </div>
{% endblock %}

{% block oob %}
  {# update any divs that show tenant data... #}
{% endblock %}

src/medux/employees/templates/employees/working_contract_card.html
{% load i18n %}
<div class="card">
  <div class="card-header">
    <h3 class="card-title">{% translate 'Working contract' %} <span class="ms-2 card-subtitle">{% translate 'Employer' %}: {{ employee.tenant }}</span></h3>

  </div>
  <div class="card-body">
    {% if working_contract %}
      <div class="datagrid">
        <div class="datagrid-item">
          <div class="datagrid-title">{% translate 'Time frame' %}</div>
          <div class="datagrid-content">
            {{ working_contract.start_date }}{% if working_contract.end_date %} - {{ working_contract.end_date }}{% endif %}
          </div>
        </div>

        <div class="datagrid-item">
          <div class="datagrid-title">{% translate 'Employment date' %}</div>
          <div class="datagrid-content">{{ working_contract.employment_date }}</div>
        </div>

        <div class="datagrid-item">
          <div class="datagrid-title">{% translate 'Notice period' %}</div>
          <div class="datagrid-content">
            {% with notice_period_weeks=working_contract.notice_period_weeks notice_period_months=working_contract.notice_period_months %}
              {% if notice_period_weeks %}
                {% blocktranslate %}{{ notice_period_weeks }} weeks{% endblocktranslate %}
              {% elif notice_period_months %}
                {% blocktranslate %}{{ notice_period_months }} months{% endblocktranslate %}
              {% else %}
                -
              {% endif %}
            {% endwith %}
          </div>
        </div>

        <div class="datagrid-item">
          <div class="datagrid-title">{% translate 'Classification' %}</div>
          <div class="datagrid-content">{{ working_contract.classification }}</div>
        </div>

        <div class="datagrid-item">
          <div class="datagrid-title">{% translate 'Intended application' %}</div>
          <div class="datagrid-content">{{ working_contract.intended_application }}</div>
        </div>

        <div class="datagrid-item">
          <div class="datagrid-title">{% translate 'Salary' %}</div>
          <div class="datagrid-content">
            <button
                class="btn btn-sm"
                hx-get="{% url 'employees:salary' user.employee.id working_contract.id %}"
                hx-swap="outerHTML">
              *****
            </button>
          </div>
        </div>

        <div class="datagrid-item">
          <div class="datagrid-title">{% translate 'Holidays' %}</div>
          <div class="datagrid-content">{{ working_contract.holidays|default:"-" }}</div>
        </div>

        {% if working_contract.holidays_special or working_contract.holidays_training %}
          <div class="datagrid-item">
            <div class="datagrid-title">{% translate 'Special holidays' %}</div>
            <div class="datagrid-content">
              {% if working_contract.holidays_special %}{% translate 'Special holidays' %}: {{ working_contract.holidays_special|default:"-" }}{% endif %}
              {% if working_contract.holidays_training %}{% translate 'Training' %}: {{ working_contract.holidays_training|default:"-" }}{% endif %}
            </div>
          </div>
        {% endif %}

      </div>
    {% else %}
      <div class="alert alert-warning">
        {% translate 'There is no working contract available. Please ask your emplyoer to add one.' %}
      </div>
    {% endif %}
  </div>
</div>

src/medux/employees/templates/employees/workingcontract_salary.html
{{ working_contract.salary }}<br/>
{{ working_contract.salary_notice }}